/***************************************************************************
                          ksmsapp.h  -  description
                             -------------------
    begin                : Sat Oct 26 2002
    copyright            : (C) 2002 by Michael Schuerig
    email                : michael@schuerig.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef KSMSAPP_H
#define KSMSAPP_H

#include <kapplication.h>
#include <ksharedptr.h>
//#include <kuniqueapplication.h>

class KSmsPrefs;
class KSmsPrefsDialog;
class MessageStore;
class MobilePhoneBook;
class PhoneAccess;

/**
 * @author Michael Schuerig
 */
class KSmsApp : public /*KUniqueApplication*/ KApplication {
Q_OBJECT
public:
    KSmsApp();
    virtual ~KSmsApp();

    void showMainWindow();

    KSharedPtr<MobilePhoneBook> phoneBook();
    KSharedPtr<MessageStore> messageStore();

public slots:
    void newMessage() const;
    void newMessage( const QString& addressee ) const;
    void openAddressBook( const QString& uid = QString::null ) const;
    void configurePreferences();

signals:
    void configChanged();

private slots:
    void slotConfigChanged();
    
private:
    KSmsApp( const KSmsApp& ); // not implemented
    KSmsApp& operator=( const KSmsApp& ); // not implemented

    class DCOPDelegate;
    DCOPDelegate* dcopDelegate_;
    
    KSmsPrefsDialog* prefsDialog_;;

    KSharedPtr<MobilePhoneBook> phoneBook_;
    const QString messagesFile_;
    KSharedPtr<MessageStore> messageStore_;
};

#endif
