/***************************************************************************
                          ksmsarchive.h  -  description
                             -------------------
    begin                : Mon Oct 28 2002
    copyright            : (C) 2002 by Michael Schuerig
    email                : michael@schuerig.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef KSMSARCHIVE_H
#define KSMSARCHIVE_H


#include <kmainwindow.h>


class KToggleAction;
class KSmsApp;
class KSmsArchiveDoc;
class KSmsArchiveView;
class KSystemTray;
class QProgressBar;
class MobilePhoneBook;
class MsgSender;


/**
 * @author Michael Schuerig
 */
class KSmsArchive : public KMainWindow {
Q_OBJECT
public: 
    KSmsArchive();
    ~KSmsArchive();
    
//    void closeEvent( QCloseEvent* ce );
    
protected:
    virtual bool queryClose();
    virtual bool queryExit();

private slots:
    void readMessages();
    void importMessagesFromPhone();
    void showProgress( unsigned long current );
    void editSender();
    void senderSelected( const MsgSender* sender );
    void quit();
    void updateToolbar();
    void updateStatusBar();
    void updateTray();
    void configureToolbars();
    void configureKeyBindings();
    void newToolbarConfig();
    void configChanged();
    void statusMessage( const QString& msg = QString::null );

private:
    KSmsArchive( const KSmsArchive& ); // not implemented
    KSmsArchive& operator=( const KSmsArchive& ); // not implemented

    void initStatusBar();
    void initActions();
    void initDocument();
    void initView();
    void initTray();

    void updateSenderAction( const MsgSender* sender );

    KSmsApp* application() const;

    enum { ID_STATUS_GENERAL, ID_STATUS_PROGRESS };
    static const QString UI_RESOURCE_FILE;
    static const QString WINDOW_NAME;

    KSmsArchiveDoc* document_;
    KSmsArchiveView* view_;

    QString senderUid_;
    
    KAction* newMsgAction_;
    KAction* deleteMsgAction_;
    KAction* importFromPhoneAction_;
    KAction* editSenderAction_;
    KAction* configureAction_;
    KToggleAction* toolbarAction_;
    KToggleAction* statusbarAction_;

    KSystemTray* tray_;
    QProgressBar* progressBar_;
};

#endif
