/***************************************************************************
                          ksmsarchivedoc.h  -  description
                             -------------------
    begin                : Mon Oct 28 2002
    copyright            : (C) 2002 by Michael Schuerig
    email                : michael@schuerig.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef KSMSARCHIVEDOC_H
#define KSMSARCHIVEDOC_H

#include <ksharedptr.h>
#include <qwidget.h>
#include <qobject.h>

#include "msgsender.h"

class MessageStore;
class MobilePhoneBook;


/**
 * @author Michael Schuerig
 */
class KSmsArchiveDoc : public QObject {
Q_OBJECT
public: 
    KSmsArchiveDoc( KSharedPtr<MobilePhoneBook> phoneBook,
                    KSharedPtr<MessageStore> messageStore,
                    QObject* parent = 0, const char* name = 0 );
    ~KSmsArchiveDoc();

    const MsgSenderList senders() const;
    uint messageCount() const;

public slots:    
    void importMessagesFromPhone();
    void readMessages();
    void saveMessages() const;
    void deleteMessage( const Message* msg );

signals:
    void messagesChangedForSender( const MsgSender* sender );
    void sendersChanged();
    void progress( unsigned long current, unsigned long max );

private slots:
    void emitMessagesChangedForSender( const MsgSender* sender );
    void emitSendersChanged();
    void emitProgress( unsigned long current, unsigned long max );
                                    
private:
    KSmsArchiveDoc( const KSmsArchiveDoc& ); // not implemented
    KSmsArchiveDoc& operator=( const KSmsArchiveDoc& ); // not implemented

    KSharedPtr<MobilePhoneBook> phoneBook_;
    KSharedPtr<MessageStore> messageStore_;
};

#endif
