/***************************************************************************
                          ksmsarchiveview.h  -  description
                             -------------------
    begin                : Mon Oct 28 2002
    copyright            : (C) 2002 by Michael Schuerig
    email                : michael@schuerig.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef KSMSARCHIVEVIEW_H
#define KSMSARCHIVEVIEW_H

#include <qwidget.h>

class QListBoxItem;
class QPopupMenu;
class QPos;
class MessageListBox;
class Message;
class MsgSender;
class KMainWindow;
class KSmsArchiveDoc;
class SenderListBox;


/**
 * @author Michael Schuerig
 */
class KSmsArchiveView : public QWidget {
Q_OBJECT
public: 
    KSmsArchiveView( KSmsArchiveDoc* document, QWidget* parent = 0, const char* name = 0 );
    ~KSmsArchiveView();

    void setMessagePopup( QPopupMenu* popup );
    const Message* selectedMessage() const;
    
public slots:
    void configChanged();
    void editCopy();
    void deleteSelectedMessage();

signals:
    void senderSelected( const MsgSender* sender );
    void copyAvailable( bool yes );
    void deleteMessageAvailable( bool yes );
    
private slots:
    void loadSendersAndMessages();
    void updateSender( const MsgSender* sender );
    void slotSenderSelected( const MsgSender* sender );
    void emitAvailable();
    void showMsgContextMenu( QListBoxItem* msgItem, const QPoint& pos );

    
private:
    KSmsArchiveView( const KSmsArchiveView& ); // not implemented
    KSmsArchiveView& operator=( const KSmsArchiveView& ); // not implemented

    void initWidgets();
    void showMessagesFor( const MsgSender* sender );

    KSmsArchiveDoc* document_;

    SenderListBox* sendersList_;
    MessageListBox* receivedMessagesList_;
    MessageListBox* sentMessagesList_;
    QPopupMenu* msgPopup_;
};

#endif
