/***************************************************************************
                          ksmsmsg.h  -  description
                             -------------------
    begin                : Sat Oct 26 2002
    copyright            : (C) 2002 by Michael Schuerig
    email                : michael@schuerig.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef KSMSMSG_H
#define KSMSMSG_H

#include <kmainwindow.h>

class KToggleAction;
class KSmsApp;
class KSmsMsgDoc;
class KSmsMsgView;
class MobilePhoneBook;


/**
 * @author Michael Schuerig
 */
class KSmsMsg : public KMainWindow {
Q_OBJECT
public: 
    KSmsMsg();
    ~KSmsMsg();

public slots:
    void setAddressee( const QString& addressee );
    void setText( const QString& text );
    
protected:
    virtual bool queryClose();
    virtual bool queryExit();

private slots:
    void close();
    void updateToolbar();
    void updateStatusBar();
    void configureToolbars();
    void configureKeyBindings();
    void updateStatus( const QString& messageText );
    void statusMessage( const QString& msg = QString::null );
    void newToolbarConfig();

private:
    KSmsMsg( const KSmsMsg& ); // not implemented
    KSmsMsg& operator=( const KSmsMsg& ); // not implemented

    void initStatusBar();
    void initActions();
    void initDocument();
    void initView();

    KSmsApp* application() const;
        
    enum { ID_STATUS_GENERAL, ID_STATUS_MSG_LENGTH };
    static const QString UI_RESOURCE_FILE;
    static const QString WINDOW_NAME;
    
    KSmsMsgDoc* document_;
    KSmsMsgView* view_;

    KAction* newMsgAction_;
    KAction* sendMsgAction_;
    KToggleAction* toolbarAction_;
    KToggleAction* statusbarAction_;
};

#endif
