/***************************************************************************
                          ksmsmsgdoc.h  -  description
                             -------------------
    begin                : Sat Oct 26 2002
    copyright            : (C) 2002 by Michael Schuerig
    email                : michael@schuerig.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef KSMSMSGDOC_H
#define KSMSMSGDOC_H

#include <qobject.h>


/**
 * @author Michael Schuerig
 */

class KSmsMsgDoc : public QObject {
Q_OBJECT
public: 
    KSmsMsgDoc( QObject* parent = 0, const char* name = 0 );
    KSmsMsgDoc( bool allowEmptyMessage,
                QObject* parent = 0, const char* name = 0 );
    ~KSmsMsgDoc();

    bool allowEmptyMessage();
    void setAllowEmptyMessage(bool allow);

    bool isMessageValid();
    bool isTextValid();
    bool isPhoneNumberValid();
        
public slots:
    void setText( const QString& text );
    void setPhoneNumber( const QString& phoneNumber );
    void sendMessage();
    void checkSpelling();

signals:
    void textChanged( const QString& text );
    void canBeSent( bool b );
    void messageWasSent( const QString& phoneNumber, const QString& text );

private:
    KSmsMsgDoc( const KSmsMsgDoc& ); // not implemented
    KSmsMsgDoc& operator=( const KSmsMsgDoc& ); // not implemented

    QString text_;
    QString phoneNumber_;
    bool allowEmptyMessage_;
};

#endif
