/***************************************************************************
                          ksmsmsgview.h  -  description
                             -------------------
    begin                : Sat Oct 26 2002
    copyright            : (C) 2002 by Michael Schuerig
    email                : michael@schuerig.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef KSMSMSGVIEW_H
#define KSMSMSGVIEW_H

#include <ksharedptr.h>
#include <qwidget.h>


class KComboBox;
class KSmsMsgDoc;
class MobilePhoneBook;
class QPushButton;
class KTextEdit;


/**
 * @author Michael Schuerig
 */
class KSmsMsgView : public QWidget {
Q_OBJECT
public: 
    KSmsMsgView( KSmsMsgDoc* document, KSharedPtr<MobilePhoneBook> phoneBook,
                 QWidget* parent = 0, const char* name = 0 );
    ~KSmsMsgView();

signals:
    void undoAvailable( bool yes );
    void redoAvailable( bool yes );
    void copyAvailable( bool yes );
    
public slots:
    void undo();
    void redo();
    void copy();
    void cut();
    void paste();
    void selectAll();
    void deselect();
    
private slots:
    void viewTextChanged();
    void docTextChanged( const QString& text );
    void updatePhoneNumbers();
    void emitUndoAvailable( bool yes );
    void emitRedoAvailable( bool yes );
    void emitCopyAvailable( bool yes );
   
private:
    KSmsMsgView( const KSmsMsgView& ); // not implemented
    KSmsMsgView& operator=( const KSmsMsgView& ); // not implemented

    void initWidgets();

    KSmsMsgDoc* document_;
    KSharedPtr<MobilePhoneBook> phoneBook_;
    
    KComboBox* phoneNumberBox_;
    KTextEdit* editor_;
    QPushButton* sendButton_;
};

#endif
