/***************************************************************************
                          ksmsprefs.cpp  -  description
                             -------------------
    begin                : Wed Nov 6 2002
    copyright            : (C) 2002 by Michael Schuerig
    email                : michael@schuerig.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include <kdebug.h>
#include <klocale.h>
 
#include "ksmsprefs.h"

namespace {
const QString SENT_MESSAGE_TEMPLATE
    = i18n( "<b>To: %receiver<br>At: %date</b><br>%text<br>\n" );
const QString RECEIVED_MESSAGE_TEMPLATE
    = i18n( "<b>From: %sender<br>At: %date</b><br>%text<br>\n" );
const QString CLIP_MESSAGE_TEMPLATE
    = i18n( "From: %sender\nTo: %receiver\nAt: %date\n%text\n" );
}
    

KSmsPrefs::KSmsPrefs()
    : KPrefs( "ksmsrc" )
{
    KPrefs::setCurrentGroup( "Phone Options" );
    addItemString( "Serial Device", &phone_device, "/dev/mobilephone" );
    addItemString( "Baudrate", &phone_baudrate, "19200" );
    addItemInt(    "Timeout", &phone_timeout, 60 );
    addItemString( "Init String", &phone_initString );
    addItemString( "SMS Store", &phone_smsStore, "SM" );
    addItemString( "Country Prefix", &phone_countryPrefix );

    KPrefs::setCurrentGroup( "GUI Options" );
    addItemBool(   "Dockable", &ui_dockable, true );
    addItemBool(   "Docked", &ui_docked, false );
    addItemBool(   "Show Phone Number", &ui_showPhoneNumber, true );
    addItemString( "Sent Message Template", &ui_sentMessageTemplate,
                   SENT_MESSAGE_TEMPLATE );
    addItemString( "Received Message Template", &ui_receivedMessageTemplate,
                   RECEIVED_MESSAGE_TEMPLATE );
    addItemString( "Clipboard Message Template", &ui_clipMessageTemplate,
                   CLIP_MESSAGE_TEMPLATE );

    readConfig();
}


KSmsPrefs::~KSmsPrefs()
{
    kdDebug() << "KSmsPrefs::~KSmsPrefs" << endl;
}


KSmsPrefs*
KSmsPrefs::instance()
{
    static KSmsPrefs* instance = new KSmsPrefs();
    return instance;
}
