/***************************************************************************
                          messagelistbox.h  -  description
                             -------------------
    begin                : Wed Nov 6 2002
    copyright            : (C) 2002 by Michael Schuerig
    email                : michael@schuerig.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef MESSAGELISTBOX_H
#define MESSAGELISTBOX_H

#include <klistbox.h>
#include <qwidget.h>

class Message;
class MessageFormatter;
class MessageList;


/**
 * @author Michael Schuerig
 */
class MessageListBox : public KListBox {
Q_OBJECT
public: 
    MessageListBox( const QString& msgTemplate,
                    QWidget* parent = 0,
                    const char* name = 0 );
    ~MessageListBox();

    const Message* selectedMessage() const;
    
public slots:
    void setMessages( const MessageList& messages );

signals:
    void messageSelected( const Message* message );

private slots:
    void emitMessageSelected( QListBoxItem* msgItem );
    
private:
    MessageListBox( const MessageListBox& ); // not implemented
    MessageListBox& operator=( const MessageListBox& ); // not implemented

    const MessageFormatter* formatter_;
};

#endif
