/***************************************************************************
                          phoneaccess.h  -  description
                             -------------------
    begin                : Wed Nov 6 2002
    copyright            : (C) 2002 by Michael Schuerig
    email                : michael@schuerig.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef PHONEACCESS_H
#define PHONEACCESS_H

#include <qobject.h>
#include <qstring.h>

#include "messageconstants.h"


class QDateTime;


/**
 * @author Michael Schuerig
 */
class PhoneAccess : public QObject {
Q_OBJECT
public: 

    struct Config {
        Config() {}
        Config( const QString& device_, const QString& baudrate_, int timeout_,
                const QString& initString_, const QString& smsStore_ )
            : device(device_), baudrate(baudrate_), timeout(timeout_),
              initString(initString_), smsStore(smsStore_) {}
        QString device;
        QString baudrate;
        int     timeout;
        QString initString;
        QString smsStore;
    };

    static PhoneAccess* instance();
    ~PhoneAccess();

signals:
    void retrievedMessage( MessageConstants::Type type,
                           const QString& number, const QDateTime& timestamp,
                           const QString& text );
//    void receivedMessage( const QString& number, const QDateTime& timestamp,
//                          const QString& text );
                          
public slots:
//    void connect();
//    void disconnect();
    void setConfig( const Config& config );
    
    void retrieveMessages();
    void sendMessage( const QString& number,
                      const QString& text );

private:
    PhoneAccess();
    PhoneAccess( const PhoneAccess& ); // not implemented
    PhoneAccess& operator=( const PhoneAccess& ); // not implemented

    Config config_;
};


#endif
