/***************************************************************************
                        phoneutils.cpp  -  description
                             -------------------
    begin                : Sat Nov 9 2002
    copyright            : (C) 2002 by Michael Schuerig
    email                : michael@schuerig.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include <kdebug.h>
#include <qstring.h>
 
#include "phoneutils.h"


namespace PhoneUtils {

namespace {
QString localCountryPrefix_;
}


QString normalizePhoneNumber( const QString& number )
{
    if ( localCountryPrefix_.isEmpty() ) {
        kdWarning() << "Country prefix not set." << endl;
    }

    QString normNumber;

    uint l = number.length();
    for ( uint i = 0; i < l; ++i ) {
        const QChar c = number[i];
        if (    c.isDigit()
             || c == '+' || c == '*'
             || c == '#' || c == 'p'
             || c == 'w' || c == 'P'
             || c == 'W' ) {
           normNumber += c;
        }
    }
    if ( normNumber.startsWith("00") ) {
        normNumber = "+" + normNumber.mid(2);
    }
    else if ( !localCountryPrefix_.isEmpty() && normNumber.startsWith("0") ) {
        normNumber = localCountryPrefix_ + normNumber.mid(1);
    }

//    kdDebug() << "original : normalized " << number << " : " << normNumber << endl;
    
    return normNumber;
}


QString
localCountryPrefix()
{
    return localCountryPrefix_;
}

void
setLocalCountryPrefix( const QString& prefix )
{
    kdDebug() << "Setting country prefix: " << prefix << endl;
    localCountryPrefix_ = prefix;
}


}
