/***************************************************************************
                          senderfactory.cpp  -  description
                             -------------------
    begin                : Tue Nov 5 2002
    copyright            : (C) 2002 by Michael Schuerig
    email                : michael@schuerig.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include <kdebug.h>
#include <qstring.h>

#include "mobilephonebook.h"
#include "phoneutils.h"
 
#include "senderfactory.h"


SenderFactory::SenderFactory()
{
}


SenderFactory::~SenderFactory()
{
}


MsgSender*
SenderFactory::newSender( MsgSenderContainer& container,
                          const QString& phoneNumber )
{
    const MobilePhoneBook::Entry entry(
        MobilePhoneBook::findEntryForNumber(phoneNumber) );

    //### use phone number from addressbook???
    return container.newSender( phoneNumber, entry.name, entry.uid );
}


MsgSender*
SenderFactory::newMyselfSender( MsgSenderContainer& container )
{
    const MobilePhoneBook::Entry myself( MobilePhoneBook::findMyself() );
    return container.newSender( myself.phoneNumber, myself.name, myself.uid );
}
