/***************************************************************************
                          senderlistbox.h  -  description
                             -------------------
    begin                : Wed Nov 6 2002
    copyright            : (C) 2002 by Michael Schuerig
    email                : michael@schuerig.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef SENDERLISTBOX_H
#define SENDERLISTBOX_H


//#include <klistbox.h>
#include <klistview.h>

class MsgSender;
class MsgSenderList;
class QListViewItem;


/**
 * @author Michael Schuerig
 */
//class SenderListBox : public KListBox {
class SenderListBox : public KListView {
Q_OBJECT
public: 
    SenderListBox( bool phoneNumberVisible = true,
                   QWidget* parent = 0, const char* name = 0 );
    ~SenderListBox();

    const MsgSender* selectedSender() const;

    bool isPhoneNumberVisible();
    
public slots:
    void setSenders( const MsgSenderList& senders );
    /**
     * @param uid Address book uid
     */
    void selectSender( const QString& uid );
    void setPhoneNumberVisible( bool visible );

signals:
    void senderSelected( const MsgSender* );

private slots:
    void emitSenderSelected( QListViewItem* senderItem );

private:
    SenderListBox( const SenderListBox& ); // not implemented
    SenderListBox& operator=( const SenderListBox& ); // not implemented
};

#endif
