/***************************************************************************
                          threadedphoneaccess.h  -  description
                             -------------------
    begin                : Sat Nov 23 2002
    copyright            : (C) 2002 by Michael Schuerig
    email                : michael@schuerig.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef THREADEDPHONEACCESS_H
#define THREADEDPHONEACCESS_H

#include <qwidget.h>
#include <kactiveobjectproxy.h>

#include "phoneaccess.h"
#include "messageconstants.h"


/**
 * @author Michael Schuerig
 */
class ThreadedPhoneAccess : public KActiveObjectProxy  {
Q_OBJECT
public:
    static ThreadedPhoneAccess* instance();
    ~ThreadedPhoneAccess();

signals:
    void retrievedMessage( MessageConstants::Type type,
                           const QString& number, const QDateTime& timestamp,
                           const QString& text );
//    void receivedMessage( const QString& number, const QDateTime& timestamp,
//                          const QString& text );

public slots:
//    void connect();
//    void disconnect();
    void setConfig( const PhoneAccess::Config& config );

    void retrieveMessages();
    void sendMessage( const QString& number,
                      const QString& text );

private slots:
    void enqueueSignal_retrievedMessage( MessageConstants::Type type,
                                         const QString& number,
                                         const QDateTime& timestamp,
                                         const QString& text );

private:
    ThreadedPhoneAccess( PhoneAccess* phone, QObject* parent = 0,
                         const char* name = 0 );

    ThreadedPhoneAccess( const ThreadedPhoneAccess& ); // not implemented
    ThreadedPhoneAccess operator=( const ThreadedPhoneAccess& ); // not implemented
    
    class SlotRequest_retrieveMessages;
    class SlotRequest_sendMessage;
    class SlotRequest_setConfig;
    class SignalRequest_retrievedMessage;
    friend class SignalRequest_retrievedMessage;
    
    void emitSignal_retrievedMessage( MessageConstants::Type type,
                                      const QString& number,
                                      const QDateTime& timestamp,
                                      const QString& text );

};

#endif
