/***************************************************************************
                          xmlinputsourcewithprogress.h  -  description
                             -------------------
    begin                : Sat Nov 9 2002
    copyright            : (C) 2002 by Michael Schuerig
    email                : michael@schuerig.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef XMLINPUTSOURCEWITHPROGRESS_H
#define XMLINPUTSOURCEWITHPROGRESS_H

#include <qstring.h>
#include <qxml.h>

class ProgressCallback;
class QIODevice;


/**
 * @author Michael Schuerig
 */
class XmlInputSourceWithProgress : public QXmlInputSource  {
public: 
    XmlInputSourceWithProgress( QIODevice* dev, ProgressCallback* progress );
    ~XmlInputSourceWithProgress();

    QChar next();
    void reset();

private:
    unsigned long pos_;
    unsigned long max_;
    unsigned long interval_;
    ProgressCallback* progress_;
};

#endif
